//PROGRAMA PARA CALCULAR LAS RAICES  DE ECUACIONES CUADRATICAS Y CUBICAS
//EMPLEANDO EL METODO DE BISECCION Y EL DE NEWTON RAPHSON

#include <iostream.h>				//PARA EL CIN Y EL COUT
#include <stdlib.h>					//PARA EXIT
#include <stdio.h>					//PARA PRINTF Y SCANF
#include <math.h>						//PARA FABS (Valor absoluto)
#include <conio.h>					//...PARA LAS RESTANTES
#define ITERACIONES 20	 			//NUMERO MAXIMO DE ITERACIONES
#define PORCENTAJE 1					//PORCENTAJE PARA BISECCION
#define CIFRAS_REPETIDAS 0.0001	//CIFRAS REPETIDAS PARA NEWTON RAPHSON
#define ESC 0x1b          			//DEFINE LA TECLA ESC

//FUNCION PARA DETERMINAR EL INTERVALO
void intervalo(int x3,int x2, int x1, int x0)
{
int res;
clrscr();
cout<<endl;
for (int cont=-10,i=2;cont<=10;cont++,i++)
	{
		res=x3*(cont*cont*cont)+x2*(cont*cont) + x1*cont + x0;
		printf("\t Cuando x= %d \t f(x)= %d \n",cont,res);
	}
}

//FUNCION A APROXIMAR
float f(float x,int x3,int x2, int x1, int x0)
{
 return ( (x3*(x*x*x)) + (x2*(x*x)) + (x1*x) + x0 );
}

//DERIVADA DE LA FUNCION  f(x)
float df(float x,int x3,int x2, int x1)
{
 return ( ((3*x3)*(x*x)) + (x2*2)*x + x1);
}



int biseccion(float Xi,float Xu,int A, int B, int C, int D)
{ //LE PASO EL VALOR DE LOS DOS INTERVALOS Y LOS COEFICIENTES

float Xr,xanterior;
clrscr();
cout<<"\t B	I	S	E	C	C	I	O	N"<<endl;
for(int cont=1;cont<=ITERACIONES;cont++)		//cont numero de iteraciones
{
	Xr=(Xi+Xu)/2;
	gotoxy(2,cont+1);printf("%d iteracion = %f",cont,Xr);

	if ( (f(Xr,A,B,C,D)) > 0 ) Xu=Xr;			//si el signo es positivo
		else
			if ( (f(Xr,A,B,C,D)) < 0 )	Xi=Xr;	//si el signo es negativo

	gotoxy(32,cont+1);	cout<<"SIGNO= "<<f(Xr,A,B,C,D);

	if(cont>2)
		{
			gotoxy(55,cont+1);
			printf("PORCENTAJE= %f ",((Xr-xanterior)/Xr)*100);
		}

	if ( fabs( ( (Xr-xanterior)/Xr) * 100)  <=  PORCENTAJE )//si X actual - X anterior es menor que 1 %
		{
		gotoxy(10,23);textcolor(128);
		cprintf("Esta es la raiz buscada  raiz x = %f",Xr);// esta es la raiz buscada.
		textcolor(2);
		getch();
		return(0);
		}

	xanterior=Xr;
}
gotoxy(1,23);textcolor(128);
cprintf("SE ALCANZO EL NMERO MAXIMO DE ITERACIONES Y NO SE ENCONTRO EL VALOR BUSCADO");
textcolor(2);
}

int newton_raphson(float x0,int A, int B, int C, int D)	//
{		//LE PASO EL INTERVALO A INICIAR Y LOS COEFICIENTES
float x;
clrscr();
cout<<"		N  E  W  T  O  N	R  A  P  H  S  O  N \n";
	for(int i=1;i<=ITERACIONES;i++)	//N=Numero maximo de iteraciones
	{
		x=x0-f(x0,A,B,C,D)/df(x0,A,B,C);
		printf("\t\t\t %diteracion = %f\n", i, x);

		if (fabs(x-x0)<CIFRAS_REPETIDAS)		//si hay 3 cifras repetidas
			{
			gotoxy(10,23);textcolor(128);
			cprintf("Esta es la raiz buscada x = %f",x);// esta es la raiz buscada.
			textcolor(2);
			return(0);
			};

		x0=x;
	}

gotoxy(1,23);textcolor(128);
printf("SE ALCANZO EL NMERO MAXIMO DE ITERACIONES Y NO SE ENCONTRO EL VALOR BUSCADO");
textcolor(2);
}


/*****************funcion principal*****************/
main()
{
int A,B,C,D;
int opcion;
float Xi,Xu;

textbackground(1);	//COLOR DE LA PANTALLA AZUL
textcolor(2);
do
{
	clrscr();
	gotoxy(10,10);printf(" 1.-METODO DE BISECCION ");
	gotoxy(10,11);printf(" 2.-METODO DE NEWTON RAPHSON ");
	gotoxy(10,12);printf(" 3.-Salir ");

	gotoxy(10,16);
	printf("QUE MTODO DESEAS USAR PARA ENCONTRAR LA RAIZ? ");
	scanf("%d",&opcion);


/***********************COMIENZA EL MENU*******************************/
switch(opcion)
{

		case 1:			//CASO 1 METODO DE BISECCION
		printf("\nDAME LOS COEFICIENTES DE LA ECUACION A A CALCULAR \n");
		printf("DAME EL COEFICIENTE DE  x^3 ");cin>>A;		//SI LA FUNCION ES CUADRATICA BASTA CON DARLE A X^3 UN VALOR DE 0
		printf("DAME EL COEFICIENTE DE  x^2 ");cin>>B;
		printf("DAME EL COEFICIENTE DE  x^1 ");cin>>C;
		printf("DAME EL COEFICIENTE DE  x^0 ");cin>>D;
		intervalo(A,B,C,D);
		printf("\nDAME EL INTERVALO ");	cin>>Xi;	//guardo el intervalo Xi
		Xu=Xi+1;		//el intervalo Xu es el que sigue
		biseccion(Xi,Xu,A,B,C,D);
	break;

	case 2:		//CASO 2 NEWTON RAPHSON
		printf("\nDAME LOS COEFICIENTES DE LA ECUACION A A CALCULAR \n");
		printf("DAME EL COEFICIENTE DE  x^3 ");cin>>A;
		printf("DAME EL COEFICIENTE DE  x^2 ");cin>>B;
		printf("DAME EL COEFICIENTE DE  x^1 ");cin>>C;
		printf("DAME EL COEFICIENTE DE  x^0 ");cin>>D;
		intervalo(A,B,C,D);
		printf("\nDAME EL INTERVALO ");	cin>>Xi;	//guardo el intervalo Xi

		newton_raphson(Xi,A,B,C,D);
	break;

	case 3:		//CASO 3 SALIR
	exit(0);		//SALIR

	default:		//SI SE PRESIONA OTRO NUMERO DIFERENTE
		{
			clrscr();gotoxy(20,12);
			printf("ESE NUMERO NO ESTA PERMITIDO INTENTE CON OTRO\n");
		}
	break;
}	//fin de switch
/***********************TERMINA EL MENU*******************************/

printf ("\nDESEAS REALIZAR OTRO PROCESO?	Para salir presione ESC...\nPresiona cualquier tecla para continuar...");

}//fin de do
while(getch()!=ESC);   //si presionas ESC se termina el BUCLE

return(0);
}